SDL_test_common.h
Go to the documentation of this file.
/*
Simple DirectMedia Layer
Copyright (C) 1997-2025 Sam Lantinga <slouken@libsdl.org>
This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.
Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:
1. The origin of this software must not be misrepresented; you must not
claim that you wrote the original software. If you use this software
in a product, an acknowledgment in the product documentation would be
appreciated but is not required.
2. Altered source versions must be plainly marked as such, and must not be
misrepresented as being the original software.
3. This notice may not be removed or altered from any source distribution.
*/
/**
* Common functions of SDL test framework.
*
* This code is a part of the SDL test library, not the main SDL library.
*/
/* Ported from original test/common.h file. */
#ifndef SDL_test_common_h_
#define SDL_test_common_h_
#include <SDL3/SDL.h>
#ifdef SDL_PLATFORM_PSP
#define DEFAULT_WINDOW_WIDTH 480
#define DEFAULT_WINDOW_HEIGHT 272
#elif defined(SDL_PLATFORM_VITA)
#define DEFAULT_WINDOW_WIDTH 960
#define DEFAULT_WINDOW_HEIGHT 544
#else
#define DEFAULT_WINDOW_WIDTH 640
#define DEFAULT_WINDOW_HEIGHT 480
#endif
typedef Uint32 SDLTest_VerboseFlags;
#define VERBOSE_VIDEO 0x00000001
#define VERBOSE_MODES 0x00000002
#define VERBOSE_RENDER 0x00000004
#define VERBOSE_EVENT 0x00000008
#define VERBOSE_AUDIO 0x00000010
#define VERBOSE_MOTION 0x00000020
/* !< Function pointer parsing one argument at argv[index], returning the number of parsed arguments,
* or a negative value when the argument is invalid */
typedef int (SDLCALL *SDLTest_ParseArgumentsFp)(void *data, char **argv, int index);
/* !< Finalize the argument parser. */
typedef void (SDLCALL *SDLTest_FinalizeArgumentParserFp)(void *arg);
typedef struct SDLTest_ArgumentParser
{
/* !< Parse an argument. */
SDLTest_ParseArgumentsFp parse_arguments;
/* !< Finalize this argument parser. Called once before parsing the first argument. */
SDLTest_FinalizeArgumentParserFp finalize;
/* !< Null-terminated array of arguments. Printed when running with --help. */
const char **usage;
/* !< User data, passed to all callbacks. */
void *data;
/* !< Next argument parser. */
struct SDLTest_ArgumentParser *next;
} SDLTest_ArgumentParser;
typedef struct
{
/* SDL init flags */
char **argv;
SDL_InitFlags flags;
SDLTest_VerboseFlags verbose;
/* Video info */
const char *videodriver;
int display_index;
SDL_DisplayID displayID;
const char *window_title;
const char *window_icon;
SDL_WindowFlags window_flags;
bool flash_on_focus_loss;
int window_x;
int window_y;
int window_w;
int window_h;
int window_minW;
int window_minH;
int window_maxW;
int window_maxH;
float window_min_aspect;
float window_max_aspect;
int logical_w;
int logical_h;
bool auto_scale_content;
SDL_RendererLogicalPresentation logical_presentation;
float scale;
int depth;
float refresh_rate;
bool fill_usable_bounds;
bool fullscreen_exclusive;
SDL_DisplayMode fullscreen_mode;
int num_windows;
SDL_Window **windows;
const char *gpudriver;
/* Renderer info */
const char *renderdriver;
int render_vsync;
bool skip_renderer;
SDL_Renderer **renderers;
SDL_Texture **targets;
/* Audio info */
const char *audiodriver;
SDL_AudioFormat audio_format;
int audio_channels;
int audio_freq;
SDL_AudioDeviceID audio_id;
/* GL settings */
int gl_red_size;
int gl_green_size;
int gl_blue_size;
int gl_alpha_size;
int gl_buffer_size;
int gl_depth_size;
int gl_stencil_size;
int gl_double_buffer;
int gl_accum_red_size;
int gl_accum_green_size;
int gl_accum_blue_size;
int gl_accum_alpha_size;
int gl_stereo;
int gl_release_behavior;
int gl_multisamplebuffers;
int gl_multisamplesamples;
int gl_retained_backing;
int gl_accelerated;
int gl_major_version;
int gl_minor_version;
int gl_debug;
int gl_profile_mask;
/* Mouse info */
SDL_Rect confine;
bool hide_cursor;
/* Options info */
SDLTest_ArgumentParser common_argparser;
SDLTest_ArgumentParser video_argparser;
SDLTest_ArgumentParser audio_argparser;
SDLTest_ArgumentParser *argparser;
} SDLTest_CommonState;
#include <SDL3/SDL_begin_code.h>
/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C" {
#endif
/* Function prototypes */
/**
* Parse command line parameters and create common state.
*
* \param argv Array of command line parameters
* \param flags Flags indicating which subsystem to initialize (i.e. SDL_INIT_VIDEO | SDL_INIT_AUDIO)
*
* \returns a newly allocated common state object.
*/
SDLTest_CommonState * SDLCALL SDLTest_CommonCreateState(char **argv, SDL_InitFlags flags);
/**
* Free the common state object.
*
* You should call SDL_Quit() before calling this function.
*
* \param state The common state object to destroy
*/
void SDLCALL SDLTest_CommonDestroyState(SDLTest_CommonState *state);
/**
* Process one common argument.
*
* \param state The common state describing the test window to create.
* \param index The index of the argument to process in argv[].
*
* \returns the number of arguments processed (i.e. 1 for --fullscreen, 2 for --video [videodriver], or -1 on error.
*/
int SDLCALL SDLTest_CommonArg(SDLTest_CommonState *state, int index);
/**
* Logs command line usage info.
*
* This logs the appropriate command line options for the subsystems in use
* plus other common options, and then any application-specific options.
* This uses the SDL_Log() function and splits up output to be friendly to
* 80-character-wide terminals.
*
* \param state The common state describing the test window for the app.
* \param argv0 argv[0], as passed to main/SDL_main.
* \param options an array of strings for application specific options. The last element of the array should be NULL.
*/
void SDLCALL SDLTest_CommonLogUsage(SDLTest_CommonState *state, const char *argv0, const char **options);
/**
* Open test window.
*
* \param state The common state describing the test window to create.
*
* \returns true if initialization succeeded, false otherwise
*/
bool SDLCALL SDLTest_CommonInit(SDLTest_CommonState *state);
/**
* Easy argument handling when test app doesn't need any custom args.
*
* \param state The common state describing the test window to create.
* \param argc argc, as supplied to SDL_main
* \param argv argv, as supplied to SDL_main
*
* \returns false if app should quit, true otherwise.
*/
bool SDLCALL SDLTest_CommonDefaultArgs(SDLTest_CommonState *state, int argc, char **argv);
/**
* Print the details of an event.
*
* This is automatically called by SDLTest_CommonEvent() as needed.
*
* \param event The event to print.
*/
void SDLCALL SDLTest_PrintEvent(const SDL_Event *event);
/**
* Common event handler for test windows if you use a standard SDL_main.
*
* \param state The common state used to create test window.
* \param event The event to handle.
* \param done Flag indicating we are done.
*/
void SDLCALL SDLTest_CommonEvent(SDLTest_CommonState *state, SDL_Event *event, int *done);
/**
* Common event handler for test windows if you use SDL_AppEvent.
*
* This does _not_ free anything in `event`.
*
* \param state The common state used to create test window.
* \param event The event to handle.
* \returns Value suitable for returning from SDL_AppEvent().
*/
SDL_AppResult SDLCALL SDLTest_CommonEventMainCallbacks(SDLTest_CommonState *state, const SDL_Event *event);
/**
* Close test window.
*
* \param state The common state used to create test window.
*
*/
void SDLCALL SDLTest_CommonQuit(SDLTest_CommonState *state);
/**
* Draws various window information (position, size, etc.) to the renderer.
*
* \param renderer The renderer to draw to.
* \param window The window whose information should be displayed.
* \param usedHeight Returns the height used, so the caller can draw more below.
*
*/
void SDLCALL SDLTest_CommonDrawWindowInfo(SDL_Renderer *renderer, SDL_Window *window, float *usedHeight);
/* Ends C function definitions when using C++ */
#ifdef __cplusplus
}
#endif
#include <SDL3/SDL_close_code.h>
#endif /* SDL_test_common_h_ */
SDL.h
SDL_AudioDeviceID
Uint32 SDL_AudioDeviceID
Definition SDL_audio.h:374
SDL_AudioFormat
SDL_AudioFormat
Definition SDL_audio.h:222
SDL_begin_code.h
SDL_close_code.h
SDL_InitFlags
Uint32 SDL_InitFlags
Definition SDL_init.h:78
SDL_AppResult
SDL_AppResult
Definition SDL_init.h:110
SDL_RendererLogicalPresentation
SDL_RendererLogicalPresentation
Definition SDL_render.h:106
SDL_Renderer
struct SDL_Renderer SDL_Renderer
Definition SDL_render.h:119
Uint32
uint32_t Uint32
Definition SDL_stdinc.h:461
SDLTest_PrintEvent
void SDLTest_PrintEvent(const SDL_Event *event)
SDLTest_CommonInit
bool SDLTest_CommonInit(SDLTest_CommonState *state)
SDLTest_CommonQuit
void SDLTest_CommonQuit(SDLTest_CommonState *state)
SDLTest_VerboseFlags
Uint32 SDLTest_VerboseFlags
Definition SDL_test_common.h:46
SDLTest_CommonDefaultArgs
bool SDLTest_CommonDefaultArgs(SDLTest_CommonState *state, int argc, char **argv)
SDLTest_CommonEvent
void SDLTest_CommonEvent(SDLTest_CommonState *state, SDL_Event *event, int *done)
SDLTest_CommonArg
int SDLTest_CommonArg(SDLTest_CommonState *state, int index)
SDLTest_CommonDrawWindowInfo
void SDLTest_CommonDrawWindowInfo(SDL_Renderer *renderer, SDL_Window *window, float *usedHeight)
SDLTest_FinalizeArgumentParserFp
void(* SDLTest_FinalizeArgumentParserFp)(void *arg)
Definition SDL_test_common.h:59
SDLTest_CommonDestroyState
void SDLTest_CommonDestroyState(SDLTest_CommonState *state)
SDLTest_CommonLogUsage
void SDLTest_CommonLogUsage(SDLTest_CommonState *state, const char *argv0, const char **options)
SDLTest_CommonEventMainCallbacks
SDL_AppResult SDLTest_CommonEventMainCallbacks(SDLTest_CommonState *state, const SDL_Event *event)
SDLTest_ParseArgumentsFp
int(* SDLTest_ParseArgumentsFp)(void *data, char **argv, int index)
Definition SDL_test_common.h:56
SDLTest_CommonCreateState
SDLTest_CommonState * SDLTest_CommonCreateState(char **argv, SDL_InitFlags flags)
SDL_DisplayID
Uint32 SDL_DisplayID
Definition SDL_video.h:75
SDL_Window
struct SDL_Window SDL_Window
Definition SDL_video.h:173
SDL_WindowFlags
Uint64 SDL_WindowFlags
Definition SDL_video.h:187
renderer
static SDL_Renderer * renderer
Definition hello.c:17
window
static SDL_Window * window
Definition hello.c:16
SDL_DisplayMode
Definition SDL_video.h:138
SDL_Rect
Definition SDL_rect.h:84
SDL_Texture
Definition SDL_render.h:134
SDLTest_ArgumentParser
Definition SDL_test_common.h:62
SDLTest_ArgumentParser::data
void * data
Definition SDL_test_common.h:70
SDLTest_ArgumentParser::usage
const char ** usage
Definition SDL_test_common.h:68
SDLTest_ArgumentParser::finalize
SDLTest_FinalizeArgumentParserFp finalize
Definition SDL_test_common.h:66
SDLTest_ArgumentParser::parse_arguments
SDLTest_ParseArgumentsFp parse_arguments
Definition SDL_test_common.h:64
SDLTest_ArgumentParser::next
struct SDLTest_ArgumentParser * next
Definition SDL_test_common.h:72
SDLTest_CommonState
Definition SDL_test_common.h:76
SDLTest_CommonState::fill_usable_bounds
bool fill_usable_bounds
Definition SDL_test_common.h:107
SDLTest_CommonState::gl_multisamplebuffers
int gl_multisamplebuffers
Definition SDL_test_common.h:143
SDLTest_CommonState::windows
SDL_Window ** windows
Definition SDL_test_common.h:111
SDLTest_CommonState::video_argparser
SDLTest_ArgumentParser video_argparser
Definition SDL_test_common.h:158
SDLTest_CommonState::window_maxH
int window_maxH
Definition SDL_test_common.h:97
SDLTest_CommonState::window_min_aspect
float window_min_aspect
Definition SDL_test_common.h:98
SDLTest_CommonState::window_y
int window_y
Definition SDL_test_common.h:91
SDLTest_CommonState::common_argparser
SDLTest_ArgumentParser common_argparser
Definition SDL_test_common.h:157
SDLTest_CommonState::gl_debug
int gl_debug
Definition SDL_test_common.h:149
SDLTest_CommonState::gl_alpha_size
int gl_alpha_size
Definition SDL_test_common.h:132
SDLTest_CommonState::gl_accelerated
int gl_accelerated
Definition SDL_test_common.h:146
SDLTest_CommonState::gl_red_size
int gl_red_size
Definition SDL_test_common.h:129
SDLTest_CommonState::window_minW
int window_minW
Definition SDL_test_common.h:94
SDLTest_CommonState::gl_stereo
int gl_stereo
Definition SDL_test_common.h:141
SDLTest_CommonState::gl_accum_blue_size
int gl_accum_blue_size
Definition SDL_test_common.h:139
SDLTest_CommonState::auto_scale_content
bool auto_scale_content
Definition SDL_test_common.h:102
SDLTest_CommonState::targets
SDL_Texture ** targets
Definition SDL_test_common.h:119
SDLTest_CommonState::audio_argparser
SDLTest_ArgumentParser audio_argparser
Definition SDL_test_common.h:159
SDLTest_CommonState::gl_accum_green_size
int gl_accum_green_size
Definition SDL_test_common.h:138
SDLTest_CommonState::num_windows
int num_windows
Definition SDL_test_common.h:110
SDLTest_CommonState::confine
SDL_Rect confine
Definition SDL_test_common.h:153
SDLTest_CommonState::flags
SDL_InitFlags flags
Definition SDL_test_common.h:79
SDLTest_CommonState::window_x
int window_x
Definition SDL_test_common.h:90
SDLTest_CommonState::gl_minor_version
int gl_minor_version
Definition SDL_test_common.h:148
SDLTest_CommonState::window_max_aspect
float window_max_aspect
Definition SDL_test_common.h:99
SDLTest_CommonState::gl_retained_backing
int gl_retained_backing
Definition SDL_test_common.h:145
SDLTest_CommonState::depth
int depth
Definition SDL_test_common.h:105
SDLTest_CommonState::argv
char ** argv
Definition SDL_test_common.h:78
SDLTest_CommonState::gl_green_size
int gl_green_size
Definition SDL_test_common.h:130
SDLTest_CommonState::gl_double_buffer
int gl_double_buffer
Definition SDL_test_common.h:136
SDLTest_CommonState::gl_major_version
int gl_major_version
Definition SDL_test_common.h:147
SDLTest_CommonState::audio_channels
int audio_channels
Definition SDL_test_common.h:124
SDLTest_CommonState::skip_renderer
bool skip_renderer
Definition SDL_test_common.h:117
SDLTest_CommonState::gl_buffer_size
int gl_buffer_size
Definition SDL_test_common.h:133
SDLTest_CommonState::window_title
const char * window_title
Definition SDL_test_common.h:86
SDLTest_CommonState::logical_w
int logical_w
Definition SDL_test_common.h:100
SDLTest_CommonState::hide_cursor
bool hide_cursor
Definition SDL_test_common.h:154
SDLTest_CommonState::window_minH
int window_minH
Definition SDL_test_common.h:95
SDLTest_CommonState::window_h
int window_h
Definition SDL_test_common.h:93
SDLTest_CommonState::gl_multisamplesamples
int gl_multisamplesamples
Definition SDL_test_common.h:144
SDLTest_CommonState::gl_depth_size
int gl_depth_size
Definition SDL_test_common.h:134
SDLTest_CommonState::gl_release_behavior
int gl_release_behavior
Definition SDL_test_common.h:142
SDLTest_CommonState::gpudriver
const char * gpudriver
Definition SDL_test_common.h:112
SDLTest_CommonState::gl_profile_mask
int gl_profile_mask
Definition SDL_test_common.h:150
SDLTest_CommonState::verbose
SDLTest_VerboseFlags verbose
Definition SDL_test_common.h:80
SDLTest_CommonState::displayID
SDL_DisplayID displayID
Definition SDL_test_common.h:85
SDLTest_CommonState::videodriver
const char * videodriver
Definition SDL_test_common.h:83
SDLTest_CommonState::render_vsync
int render_vsync
Definition SDL_test_common.h:116
SDLTest_CommonState::gl_accum_alpha_size
int gl_accum_alpha_size
Definition SDL_test_common.h:140
SDLTest_CommonState::audio_id
SDL_AudioDeviceID audio_id
Definition SDL_test_common.h:126
SDLTest_CommonState::flash_on_focus_loss
bool flash_on_focus_loss
Definition SDL_test_common.h:89
SDLTest_CommonState::refresh_rate
float refresh_rate
Definition SDL_test_common.h:106
SDLTest_CommonState::window_icon
const char * window_icon
Definition SDL_test_common.h:87
SDLTest_CommonState::display_index
int display_index
Definition SDL_test_common.h:84
SDLTest_CommonState::window_maxW
int window_maxW
Definition SDL_test_common.h:96
SDLTest_CommonState::scale
float scale
Definition SDL_test_common.h:104
SDLTest_CommonState::audio_format
SDL_AudioFormat audio_format
Definition SDL_test_common.h:123
SDLTest_CommonState::logical_presentation
SDL_RendererLogicalPresentation logical_presentation
Definition SDL_test_common.h:103
SDLTest_CommonState::renderdriver
const char * renderdriver
Definition SDL_test_common.h:115
SDLTest_CommonState::window_w
int window_w
Definition SDL_test_common.h:92
SDLTest_CommonState::fullscreen_exclusive
bool fullscreen_exclusive
Definition SDL_test_common.h:108
SDLTest_CommonState::audiodriver
const char * audiodriver
Definition SDL_test_common.h:122
SDLTest_CommonState::window_flags
SDL_WindowFlags window_flags
Definition SDL_test_common.h:88
SDLTest_CommonState::gl_accum_red_size
int gl_accum_red_size
Definition SDL_test_common.h:137
SDLTest_CommonState::renderers
SDL_Renderer ** renderers
Definition SDL_test_common.h:118
SDLTest_CommonState::argparser
SDLTest_ArgumentParser * argparser
Definition SDL_test_common.h:161
SDLTest_CommonState::fullscreen_mode
SDL_DisplayMode fullscreen_mode
Definition SDL_test_common.h:109
SDLTest_CommonState::gl_stencil_size
int gl_stencil_size
Definition SDL_test_common.h:135
SDLTest_CommonState::logical_h
int logical_h
Definition SDL_test_common.h:101
SDLTest_CommonState::audio_freq
int audio_freq
Definition SDL_test_common.h:125
SDLTest_CommonState::gl_blue_size
int gl_blue_size
Definition SDL_test_common.h:131
SDL_Event
Definition SDL_events.h:989